@echo off

setlocal
pushd "%~dp0"

::_____________________________________________
::
::	INIT
::_____________________________________________
::

::	Read INI file
	For /f "eol=; delims=" %%x in (EveryTheme.ini) do call set %%x

	color 80

::-------------------------------------------
::	Check INI entries
::-------------------------------------------
	If not exist "%EXE%" set ERROR=Check EXE=%EXE%

	If not exist "%INI%" set ERROR=Check INI=%INI%

	If not exist "%EXPORT%\" set ERROR=Check EXPORT=%EXPORT%
	
	If not DEFINED ICON set ICON=%EXE%
	For /f "delims=," %%x in ("%ICON%") do if not exist "%%x" set ERROR=Check ICON=%ICON%

	If Defined ERROR (
		color 0C
		echo.
		echo.  EveryTheme.ini misconfiguration.
		echo.  %ERROR%
		echo.
		echo.  
		echo.  ^( INI: %~dp0Everytheme.ini ^)
		echo.
		echo.
		pause
		goto :EOF
	)

	

::_____________________________________________
::
::	ACTION!
::_____________________________________________
::	

::	Check parameters. If .everytheme file: import it.
::	If other parameter: warning + quit

	If [%1] neq [] (	:: There are parameters
		If /i [%~x1] equ [.everytheme] (
			findstr /i /v /R "_bold= _color= _font= ^[ ]*;" %1 || goto :IMPORT
		)	
		:: If we end up here: Invalid filecontent or invalid fileextension
		echo.
		echo.	Not a valid Everything theme file: %1.
		echo.
		pause
	goto :EOF
	)


::	We're here because there was no parm given. Show menu.

::	If not registered, goto :REGISTER routine
	set REGISTERED=NOT
	REG.exe QUERY "HKCU\Software\Classes\.Everytheme\Shell\Import\Command" >nul 2>nul && set REGISTERED=already

	echo.---------------------------------------------------------
	echo.	Shell integration %REGISTERED% installed !
	echo.---------------------------------------------------------
	echo.	
	echo.	[E] - Export current Everyting color scheme
	echo.	
	echo.	[I] - (re-) Install shell integration
	echo.	[R] - Remove shell integration
	echo.	[Q] - Quit
	echo.	
	echo.
	echo.	      When the shell integration is installed,	
	echo.	      you can double-click a .Everytheme file 
	echo.	      to import that color scheme.
	echo.	      Everything will be automatically stopped and
	echo.	      restarted to activate this new color scheme.
	echo.	
	echo.
	CHOICE.exe /C EIRQ /M "Select E, I, R or Q"

	Goto Choice%ERRORLEVEL%
	
::	End of program


::_____________________________________________
::
::	SUBROUTINES
::_____________________________________________
::


::------------------------------------------------------
	:CHOICE1	:: Export current Everyting color scheme
::------------------------------------------------------

::	Export the current color settings to a file

	:NAMELOOP
	::	Ask for filename
		Set /p ThemeName="Name for current color settings: "
		If exist "%EXPORT%\%ThemeName%.everytheme" (
			echo.
			echo.
			CHOICE.exe /M "Theme """%ThemeName%""" already exists. Overwrite?"
			If ERRORLEVEL 2 goto :NAMELOOP
		)

	::	export themesettings
		findstr /i "_color= _bold= _font=" "%INI%" > "%EXPORT%\%ThemeName%.everytheme"
		echo.
		echo.   Exported theme can be found here:
		echo.   "%EXPORT%\%ThemeName%.everytheme"
		echo.
		pause
goto :EOF	




::------------------------------------------------------
	:CHOICE2	:: Install shell integration
::------------------------------------------------------

::	Register .Everytheme file extension

	(
	REG.exe ADD "HKCU\Software\Classes\.Everytheme" /ve /d "Everything Theme" -f  
	REG.exe ADD "HKCU\Software\Classes\.Everytheme\DefaultIcon" /ve /d "%ICON%" -f
	REG.exe ADD "HKCU\Software\Classes\.Everytheme\Shell" /ve /d "Import" -f
	REG.exe ADD "HKCU\Software\Classes\.Everytheme\Shell\Import\Command" /ve /d """"%~f0""" """"%%1""""" -f
	) >nul
goto :EOF


::------------------------------------------------------
	:CHOICE3	:: Unregister .Everytheme file extension
::------------------------------------------------------

	REG.exe DELETE "HKCU\Software\Classes\.Everytheme" /f

goto :EOF


::------------------------------------------------------
	:CHOICE4	:: Quit
::------------------------------------------------------

goto :EOF



::------------------------------------------------------
	:IMPORT		:: Import the .everytheme color scheme
::------------------------------------------------------


::	Stop running Everything
	start /wait "" "%EXE%" -quit

::	Load INI entries
	Copy /b "%INI%" + %1 "%INI%" >nul

	
::	Start Everything
	start "" "%EXE%"

goto :EOF


